%%% $Id: GravForceExample.oz,v 1.1 2007/10/22 06:34:09 leavens Exp leavens $
%%% AUTHOR: Gary T. Leavens
%%% for examples of use, see GravForceExampleTest.oz

declare
G = 6.670e~11 %% UNITS: N * m^2 / kg^2

fun {Square R}
   %% UNITS: m -> m^2
   R*R
end

fun {GravForce M1 R M2}
   %% UNITS: kg x m x kg -> N
   if R == 0.0 then 0.0
   else G * M1 * M2 / {Square R}
   end
end

fun {GravField M1}
   %% UNITS: kg -> m -> kg -> N
   fun {$ R}
      fun {$ M2}
	 if R == 0.0 then 0.0
	 else G * M1 * M2 / {Square R}
	 end
      end
   end
end

